<html>
<head>
<title>Ogre::RadixSort&lt; TContainer, TContainerValueType, TCompValueType &gt; Class Template Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RadixSort&lt; TContainer, TContainerValueType, TCompValueType &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RadixSort" -->
<p>Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard STL containers.  
 <a href="classOgre_1_1RadixSort.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>&gt;</code></p>

<p><a href="classOgre_1_1RadixSort-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef TContainer::iterator&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#ae6832006de9925d59d8795d4f708f08f">ContainerIter</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a2c982200600a22b21906e3f43a0a962d">RadixSort</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a8f49cae4360e7c83b6ca7cf5714db761">~RadixSort</a> ()</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;class TFunction &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a4fc283b678dfda772eb6600436d97579">sort</a> (TContainer &amp;container, TFunction func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Main sort function.  <a href="#a4fc283b678dfda772eb6600436d97579"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::vector&lt; <a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>, <br class="typebreak"/>
<a class="el" href="classOgre_1_1STLAllocator.html">STLAllocator</a>&lt; <a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>, <br class="typebreak"/>
<a class="el" href="namespaceOgre.html#ad4ca7bb13f62006a192960fda3b0151e">GeneralAllocPolicy</a> &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Temp sort storage.  <a href="#a94bd2347af6de0613d1e22fb0188e37e"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a214c198ead344cf63ea82336b5e63f54">sortPass</a> (int byteIndex)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">finalPass</a> (int byteIndex, T val)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a9d5c1b55a50cded48d3ccbe38182766e">finalPass</a> (int byteIndex, int val)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a985875ef2e1f317eea143cac7b7dc529">finalPass</a> (int byteIndex, float val)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#ac54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a> (int byteIndex, TCompValueType val)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668">mCounters</a> [4][256]</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value.  <a href="#ac6718da2036c0980c508536bbdf64668"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64">mOffsets</a> [256]</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Beta-pass offsets.  <a href="#a0d46f30b03aedeb510dec893bee18e64"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a9c004d058dec49d422482103af7a06dd">mSortSize</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sort area size.  <a href="#a9c004d058dec49d422482103af7a06dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a02ac6146623e353cd5c36ffa4eb30373">mNumPasses</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of passes for this type.  <a href="#a02ac6146623e353cd5c36ffa4eb30373"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a27a54d016222e2bfb851bd2b58672a8f">mSortArea1</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#ad374af1c128ab643ae5d8b2f3cfd6593">mSortArea2</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a64c81c8e836cea804a1342fa23a85540">mDest</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">TContainer&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RadixSort.html#a98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><h3>template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt;<br/>
class Ogre::RadixSort&lt; TContainer, TContainerValueType, TCompValueType &gt;</h3>

<p>Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard STL containers. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>A radix sort is a very fast sort algorithm. It doesn't use comparisons and thus is able to break the theoretical minimum O(N*logN) complexity. Radix sort is complexity O(k*N), where k is a constant. Note that radix sorting is not in-place, it requires additional storage, so it trades memory for speed. The overhead of copying means that it is only faster for fairly large datasets, so you are advised to only use it for collections of at least a few hundred items. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This is a template class to allow it to deal with a variety of containers, and a variety of value types to sort on. In addition to providing the container and value type on construction, you also need to supply a functor object which will retrieve the value to compare on for each item in the list. For example, if you had an std::vector of by-value instances of an object of class 'Bibble', and you wanted to sort on Bibble::getDoobrie(), you'd have to firstly create a functor like this: <div class="fragment"><pre class="fragment">        <span class="keyword">struct </span>BibbleSortFunctor
        {
            <span class="keywordtype">float</span> operator()(<span class="keyword">const</span> Bibble&amp; val)<span class="keyword"> const</span>
<span class="keyword">            </span>{
                <span class="keywordflow">return</span> val.getDoobrie();
            }
        }
</pre></div> Then, you need to declare a <a class="el" href="classOgre_1_1RadixSort.html" title="Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard...">RadixSort</a> class which names the container type, the value type in the container, and the type of the value you want to sort by. You can then call the sort function. E.g. <div class="fragment"><pre class="fragment">        RadixSort&lt;BibbleList, Bibble, float&gt; radixSorter;
        BibbleSortFunctor functor;

        radixSorter.sort(myBibbleList, functor);
</pre></div> You should try to reuse <a class="el" href="classOgre_1_1RadixSort.html" title="Class for performing a radix sort (fast comparison-less sort based on byte value) on various standard...">RadixSort</a> instances, since repeated allocation of the internal storage is then avoided. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>Radix sorting is often associated with just unsigned integer values. Our implementation can handle both unsigned and signed integers, as well as floats (which are often not supported by other radix sorters). doubles are not supported; you will need to implement your functor object to convert to float if you wish to use this sort routine. </dd></dl>

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00088">88</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="ae6832006de9925d59d8795d4f708f08f"></a><!-- doxytag: member="Ogre::RadixSort::ContainerIter" ref="ae6832006de9925d59d8795d4f708f08f" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef TContainer::iterator <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#ae6832006de9925d59d8795d4f708f08f">ContainerIter</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00091">91</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

</div>
</div>
<a class="anchor" id="a94bd2347af6de0613d1e22fb0188e37e"></a><!-- doxytag: member="Ogre::RadixSort::SortVector" ref="a94bd2347af6de0613d1e22fb0188e37e" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef std::vector&lt;<a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>, <a class="el" href="classOgre_1_1STLAllocator.html">STLAllocator</a>&lt;<a class="el" href="structOgre_1_1RadixSort_1_1SortEntry.html">SortEntry</a>, <a class="el" href="namespaceOgre.html#ad4ca7bb13f62006a192960fda3b0151e">GeneralAllocPolicy</a>&gt; &gt; <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Temp sort storage. </p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00113">113</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a2c982200600a22b21906e3f43a0a962d"></a><!-- doxytag: member="Ogre::RadixSort::RadixSort" ref="a2c982200600a22b21906e3f43a0a962d" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00237">237</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8f49cae4360e7c83b6ca7cf5714db761"></a><!-- doxytag: member="Ogre::RadixSort::~RadixSort" ref="a8f49cae4360e7c83b6ca7cf5714db761" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::~<a class="el" href="classOgre_1_1RadixSort.html">RadixSort</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00238">238</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="acaa8140c8ba0be6840a17545b166a0f0"></a><!-- doxytag: member="Ogre::RadixSort::finalPass" ref="acaa8140c8ba0be6840a17545b166a0f0" args="(int byteIndex, T val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">finalPass</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>byteIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>val</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00140">140</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>.</p>

</div>
</div>
<a class="anchor" id="a9d5c1b55a50cded48d3ccbe38182766e"></a><!-- doxytag: member="Ogre::RadixSort::finalPass" ref="a9d5c1b55a50cded48d3ccbe38182766e" args="(int byteIndex, int val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">finalPass</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>byteIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>val</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00147">147</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

</div>
</div>
<a class="anchor" id="a985875ef2e1f317eea143cac7b7dc529"></a><!-- doxytag: member="Ogre::RadixSort::finalPass" ref="a985875ef2e1f317eea143cac7b7dc529" args="(int byteIndex, float val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#acaa8140c8ba0be6840a17545b166a0f0">finalPass</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>byteIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>val</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00180">180</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac54a7d0ddf8b1f42f4d33dc0b9aec0cd"></a><!-- doxytag: member="Ogre::RadixSort::getByte" ref="ac54a7d0ddf8b1f42f4d33dc0b9aec0cd" args="(int byteIndex, TCompValueType val)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">unsigned char <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#ac54a7d0ddf8b1f42f4d33dc0b9aec0cd">getByte</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>byteIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TCompValueType&#160;</td>
          <td class="paramname"><em>val</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00226">226</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00147">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::finalPass()</a>, <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>, and <a class="el" href="OgreRadixSort_8h_source.html#l00121">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sortPass()</a>.</p>

</div>
</div>
<a class="anchor" id="a4fc283b678dfda772eb6600436d97579"></a><!-- doxytag: member="Ogre::RadixSort::sort" ref="a4fc283b678dfda772eb6600436d97579" args="(TContainer &amp;container, TFunction func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
<div class="memtemplate">
template&lt;class TFunction &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a4fc283b678dfda772eb6600436d97579">sort</a> </td>
          <td>(</td>
          <td class="paramtype">TContainer &amp;&#160;</td>
          <td class="paramname"><em>container</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">TFunction&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Main sort function. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">container</td><td>A container of the type you declared when declaring </td></tr>
    <tr><td class="paramname">func</td><td>A functor which returns the value for comparison when given a container value </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00246">246</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

</div>
</div>
<a class="anchor" id="a214c198ead344cf63ea82336b5e63f54"></a><!-- doxytag: member="Ogre::RadixSort::sortPass" ref="a214c198ead344cf63ea82336b5e63f54" args="(int byteIndex)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a214c198ead344cf63ea82336b5e63f54">sortPass</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>byteIndex</em></td><td>)</td>
          <td><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00121">121</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00140">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::finalPass()</a>, and <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="ac6718da2036c0980c508536bbdf64668"></a><!-- doxytag: member="Ogre::RadixSort::mCounters" ref="ac6718da2036c0980c508536bbdf64668" args="[4][256]" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#ac6718da2036c0980c508536bbdf64668">mCounters</a>[4][256]<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Alpha-pass counters of values (histogram) 4 of them so we can radix sort a maximum of a 32bit value. </p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00095">95</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00147">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::finalPass()</a>, <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>, and <a class="el" href="OgreRadixSort_8h_source.html#l00121">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sortPass()</a>.</p>

</div>
</div>
<a class="anchor" id="a64c81c8e836cea804a1342fa23a85540"></a><!-- doxytag: member="Ogre::RadixSort::mDest" ref="a64c81c8e836cea804a1342fa23a85540" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a>* <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a64c81c8e836cea804a1342fa23a85540">mDest</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00117">117</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>.</p>

</div>
</div>
<a class="anchor" id="a02ac6146623e353cd5c36ffa4eb30373"></a><!-- doxytag: member="Ogre::RadixSort::mNumPasses" ref="a02ac6146623e353cd5c36ffa4eb30373" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a02ac6146623e353cd5c36ffa4eb30373">mNumPasses</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Number of passes for this type. </p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00101">101</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00226">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::getByte()</a>, and <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>.</p>

</div>
</div>
<a class="anchor" id="a0d46f30b03aedeb510dec893bee18e64"></a><!-- doxytag: member="Ogre::RadixSort::mOffsets" ref="a0d46f30b03aedeb510dec893bee18e64" args="[256]" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a0d46f30b03aedeb510dec893bee18e64">mOffsets</a>[256]<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Beta-pass offsets. </p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00097">97</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00147">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::finalPass()</a>, and <a class="el" href="OgreRadixSort_8h_source.html#l00121">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sortPass()</a>.</p>

</div>
</div>
<a class="anchor" id="a27a54d016222e2bfb851bd2b58672a8f"></a><!-- doxytag: member="Ogre::RadixSort::mSortArea1" ref="a27a54d016222e2bfb851bd2b58672a8f" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a> <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a27a54d016222e2bfb851bd2b58672a8f">mSortArea1</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00114">114</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>.</p>

</div>
</div>
<a class="anchor" id="ad374af1c128ab643ae5d8b2f3cfd6593"></a><!-- doxytag: member="Ogre::RadixSort::mSortArea2" ref="ad374af1c128ab643ae5d8b2f3cfd6593" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a> <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#ad374af1c128ab643ae5d8b2f3cfd6593">mSortArea2</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00115">115</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>.</p>

</div>
</div>
<a class="anchor" id="a9c004d058dec49d422482103af7a06dd"></a><!-- doxytag: member="Ogre::RadixSort::mSortSize" ref="a9c004d058dec49d422482103af7a06dd" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a9c004d058dec49d422482103af7a06dd">mSortSize</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sort area size. </p>

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00099">99</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00147">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::finalPass()</a>, <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>, and <a class="el" href="OgreRadixSort_8h_source.html#l00121">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sortPass()</a>.</p>

</div>
</div>
<a class="anchor" id="aee22c4e565142bc7097bf90db73115d9"></a><!-- doxytag: member="Ogre::RadixSort::mSrc" ref="aee22c4e565142bc7097bf90db73115d9" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RadixSort.html#a94bd2347af6de0613d1e22fb0188e37e">SortVector</a>* <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#aee22c4e565142bc7097bf90db73115d9">mSrc</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00116">116</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00147">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::finalPass()</a>, <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>, and <a class="el" href="OgreRadixSort_8h_source.html#l00121">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sortPass()</a>.</p>

</div>
</div>
<a class="anchor" id="a98e68e712c66b7d02426d76382b4bff4"></a><!-- doxytag: member="Ogre::RadixSort::mTmpContainer" ref="a98e68e712c66b7d02426d76382b4bff4" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class TContainer, class TContainerValueType, typename TCompValueType&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">TContainer <a class="el" href="classOgre_1_1RadixSort.html">Ogre::RadixSort</a>&lt; TContainer, TContainerValueType, TCompValueType &gt;::<a class="el" href="classOgre_1_1RadixSort.html#a98e68e712c66b7d02426d76382b4bff4">mTmpContainer</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreRadixSort_8h_source.html#l00118">118</a> of file <a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a>.</p>

<p>Referenced by <a class="el" href="OgreRadixSort_8h_source.html#l00246">Ogre::RadixSort&lt; RenderablePassList, RenderablePass, uint32 &gt;::sort()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreRadixSort_8h_source.html">OgreRadixSort.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:02
</p>
</body>
</html>
